package fixstyle;

import java.util.ArrayList;

public class ModifiableTokenStreamProcessor
{
    ArrayList list;

    String[] modifier =
        {
            "public",
            "protected",
            "private",
            "abstract",
            "static",
            "final",
            "transient",
            "volatile",
            "synchronized",
            "native",
            "strictfp",
            };

    public ModifiableTokenStreamProcessor(ArrayList list)
    {
        this.list = list;
    }

    public void process()
    {
        boolean swapped;
        do
        {
            swapped = false;
            
            int length = list.size();
            for (int index = 0; index < length; index++)
            {
                XToken token = ((XToken) list.get(index));
               
                if (!(token instanceof XTokenReal))
                {
                    continue;
                }
                
                String text = token.text;

                int j = getIndexOfModifier(text);
                if (j < 0)
                {
                    continue;
                }
                
                int index2 = getIndexOfNextRealToken(index);
                if (index2 < 0)
                {
                    continue;
                }

                XToken token2 = ((XToken) list.get(index2));
                String text2 = token2.text;

                int j2 = getIndexOfModifier(text2);
                if (j2 < 0)
                {
                    continue;
                }
                
                if (j2 < j)
                {
                    // swap...
                    Object temp = token;
                    list.set(index, list.get(index2));
                    list.set(index2, temp);

                    swapped = true;
                }
            }
        } while (swapped == true);
    }
    
    private int getIndexOfModifier(String text)
    {
        int length = modifier.length;
        for (int i = 0; i < length; i++)
        {
            if (modifier[i].equals(text))
            {
                return i;
            }
        }

        // not found...

        return -1;
    }

    int getIndexOfNextRealToken(int i)
    {
        i++;
        while (list.get(i) instanceof XTokenWhiteSpace)
        {
            i++;
        }
        return i;
    }
}
